//+------------------------------------------------------------------+
//|                                                          RSI.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        htTakeProfit://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "htTakeProfit://www.metaquotes.net"
extern int Magic = 748036;
extern double SL = 20;
extern double TP = 5;
extern double lot = 0.1;
extern int MaxOrders = 2;
extern int hour_start = 8;
extern int hour_end = 18;
extern  bool use_hidden_stop_loss = false;
extern int hidden_sl = 20;
extern  bool use_hidden_take_profit = false;
extern  int hidden_tp = 10;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

void hidden_take_profit()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if ( OrderSymbol()==Symbol()  )
     {
  if (OrderType() == OP_BUY &&  OrderOpenPrice()+hidden_tp*Point<=Bid )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
  if (OrderType() == OP_SELL &&  OrderOpenPrice()-hidden_tp*Point>=Ask  )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
  
      }
  }
  return;
}

void hidden_stop_loss()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if ( OrderSymbol()==Symbol()  )
     {
  if (OrderType() == OP_BUY &&  OrderOpenPrice()-hidden_sl*Point+Magic>=Bid )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
  if (OrderType() == OP_SELL &&  OrderOpenPrice()+hidden_sl*Point+Magic<=Ask  )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
  
      }
  }
  return;
}
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  if (use_hidden_stop_loss)           hidden_stop_loss();
if (use_hidden_take_profit)       hidden_take_profit();
  double total;
  total=OrdersTotal();
  double Range;
  if(Close[1]>Open[1])Range=(Close[1]-Open[1])*10000;
  if(Close[1]<Open[1])Range=(Open[1]-Close[1])*10000;
  double MA,MA0;
  MA= iMA(Symbol(),0,24,0,MODE_EMA,PRICE_OPEN,1);
  MA0= iMA(Symbol(),0,4,0,MODE_EMA,PRICE_CLOSE,0);
  
  if(CheckTodaysOrders() >= MaxOrders)
  {

return(0); // abort
}

//----
   if(total < 1)
   {
   if(Hour()>=hour_start && Hour()<=hour_end && Close[2]>MA && Close[1]>MA && Close[0]<=MA0 && Range>=5)
   {
   OrderSend(Symbol(),OP_BUY,lot,NormalizeDouble(Ask,4),5,NormalizeDouble(Ask,4)-SL*Point,NormalizeDouble(Ask,4)+TP*Point,NULL,Magic,0,Green);
   }
   if(Hour()>=hour_start && Hour()<=hour_end && Close[2]<MA && Close[1]<MA && Close[0]>=MA0 && Range>=5)
   {
   OrderSend(Symbol(),OP_SELL,lot,NormalizeDouble(Bid,4),5,NormalizeDouble(Bid,4)+SL*Point,NormalizeDouble(Bid,4)-TP*Point,NULL,Magic,0,Red);
   }
   }

   return(0);
}   
// function

int CheckTodaysOrders(){

int TodaysOrders = 0;

for(int i = OrdersTotal()-1; i >=0; i--){

OrderSelect(i, SELECT_BY_POS,MODE_TRADES);

if(TimeDayOfYear(OrderOpenTime()) == TimeDayOfYear(TimeCurrent())){

TodaysOrders += 1;

}

}

for(i = OrdersHistoryTotal()-1; i >=0; i--){

OrderSelect(i, SELECT_BY_POS,MODE_HISTORY);

if(TimeDayOfYear(OrderOpenTime()) == TimeDayOfYear(TimeCurrent())){

TodaysOrders += 1;

}

}

return(TodaysOrders);

}
   

//+------------------------------------------------------------------+

